// Project 18 - Sending numbers from USART to PC
#include <stdlib.h> 
#include <stdio.h>
#include <avr/io.h>
#include <util/delay.h>
#define USART_BAUDRATE 4800
#define UBRR_VALUE 12

void USARTInit(void)
{
    // Set baud rate registers
    UBRR0H = (uint8_t)(UBRR_VALUE>>8);
    UBRR0L = (uint8_t)UBRR_VALUE;

    // Set data frame format to 8 data bits, no parity, 1 stop bit
    UCSR0C |= (1<<UCSZ01)|(1<<UCSZ00);

    // enable transmission and reception
    UCSR0B |= (1<<RXEN0)|(1<<TXEN0);
}

void USARTSendByte(unsigned char u8Data) // send a byte to USART
{
    // wait while previous byte is sent
    while(!(UCSR0A&(1<<UDRE0))){};
    // Transmit data
    UDR0 = u8Data;
}

void sendString(char myString[])
{
    uint8_t a = 0;
    while (myString[a])
    {
        USARTSendByte(myString[a]);
        a++;
    }
}

int main (void)
{
    char a[10] = "Float - ";  
    char b[10] = "Integer - ";
    char t[10] = ""; // for our dtostrf test
    char newline[4] = "\r\n"; // works
    int16_t  i = -32767;      // works with integer range -32767 to 32767
    float j = -12345.67;

    //Initialize USART
    USARTInit();
    while(1)
    {
        dtostrf((float)i,12,0,t);  
        sendString(b);  // "Integer - "  
        printf(t);  // send integer
        sendString(newline);
        _delay_ms(1000);
	  
	dtostrf(j,12,2,t);  
        sendString(a);    // "Float - " 
        sendString(t);    // send float
        sendString(newline);
        _delay_ms(1000);
    }
}
