// Project 33 – Experimenting with RGB LEDs and PWM

#include <avr/io.h>
#include <util/delay.h>
#define wait 10

void initPWM(void) 
{
    // Timer 1A and 1B
    TCCR1A |= (1 << WGM10);  // Fast PWM mode
    TCCR1B |= (1 << WGM12);  // Fast PWM mode
    TCCR1B |= (1 << CS11);   
    TCCR1A |= (1 << COM1A1); // PWM to OCR1A - PB1 
    TCCR1A |= (1 << COM1B1); // PWM to OCR1B - PB2
	
    // Timer 2
    TCCR2A |= (1 << WGM20);  // Fast PWM mode 
    TCCR2A |= (1 << WGM21);  // Fast PWM mode
    TCCR2B |= (1 << CS21);   
    TCCR2A |= (1 << COM2A1); // PWM to OCR2A - PB3
}

void PWMblue(uint8_t duty)
// Blue LED is on PB1
{
    OCR1A = duty;
}

void PWMred(uint8_t duty)
// Red LED is on PB3
{
    OCR2A = duty;
}

void PWMgreen(uint8_t duty)
// Green LED is on PB2
{
    OCR1B = duty;
}

void setup()
{
}

int main(void)
{
    DDRB |= (1 << PORTB1)|(1 << PORTB2)|(1 << PORTB3); // set PORTB pins 1 2 3 as outputs
    initPWM();
    uint8_t a;

    while(1)
    { 
        // red to green
	for (a=1; a<255; a++)
	{
         PWMred(255-a);
         PWMgreen(a);
         _delay_ms(wait);
    }
	
        // green to blue
        for (a=1; a<255; a++)
        {
            PWMgreen(255-a);
            PWMblue(a);
            _delay_ms(wait);
	}
	
	// blue to red
	for (a=1; a<255; a++)
	{
            PWMblue(255-a);
            PWMred(a);
            _delay_ms(wait);	
        }
    }	
}